function g2 = G2(pvar,pfix, Sel, N, dat,qps,modelname)


eval(['simdat = ' modelname '(pvar,pfix, Sel, N);'])

MinRTallowed = -0.1; % all simulated RTs must be strictly greater than (not equal) this to count - this is mainly important when you have something like, for example, starting point variability, which may cause some trials to start ABOVE the bound! It is not disallowed in simulation, but setting this minimum here will render the fit of such trials attrocious so fminsearch will scurry away from such bogus parameter values naturally.

% Now count the number of simulated trials falling in each of the quantile
% bins of the real data. 'E' here refers to the "Expected value" from the
% typical chi-squared formulation.
% dig out each column as its own vector for convenience:
cond = simdat(:,1);
val = simdat(:,2);
outcome = simdat(:,3);
RT = simdat(:,4);
for c=1:size(dat.n,3)   %  number of conditions
    for v=1:size(dat.n,2)   %  number of value conditions
        numtr_thiscond = length(find(cond==c & val==v));
        for n=1:length(qps)  % quantiles
            if n==1
                pred(n,1,v,c) = length(find(cond==c & val==v & outcome==0 & RT<=dat.q(n,1,v,c) & RT>MinRTallowed))./numtr_thiscond;
                pred(n,2,v,c) = length(find(cond==c & val==v & outcome==1 & RT<=dat.q(n,2,v,c) & RT>MinRTallowed))./numtr_thiscond;
            else
                pred(n,1,v,c) = length(find(cond==c & val==v & outcome==0 & RT<=dat.q(n,1,v,c) & RT>dat.q(n-1,1,v,c)))./numtr_thiscond;
                pred(n,2,v,c) = length(find(cond==c & val==v & outcome==1 & RT<=dat.q(n,2,v,c) & RT>dat.q(n-1,2,v,c)))./numtr_thiscond;
            end
        end
        pred(n+1,1,v,c) = length(find(cond==c & val==v & outcome==0 & RT>dat.q(end,1,v,c)))./numtr_thiscond;
        pred(n+1,2,v,c) = length(find(cond==c & val==v & outcome==1 & RT>dat.q(end,2,v,c)))./numtr_thiscond;
    end
end


% compute G-square
g2=0;
for c=1:size(pred,4) % condition
    for v=1:size(pred,3) % value
        for n=1:size(pred,1) % quantile
            for o=1:size(pred,2)   % correct/error
                pij = dat.pb(n,o,v,c)./sum(dat.n(:,v,c));
                g2 = g2 + sum(dat.n(:,v,c))*pij*log(pij/(pred(n,o,v,c)+0.0001));
            end
        end
    end
end
g2=g2*2;

